/*
{
  "CREDIT": "SHOWSYNC",
  "CATEGORIES" : [
    "Pattern"
  ],
  "DESCRIPTION" : "My First ISF Shader",
  "ISFVSN" : "2",
  "INPUTS" : [
    {
      "NAME" : "inputImage",
      "TYPE" : "image"
    },
    {
      "NAME" : "radians",
      "TYPE" : "float",
      "DEFAULT" : 0
    },
    {
      "NAME" : "density",
      "TYPE" : "float",
      "DEFAULT" : 10
     }
  ]
}
*/

#define TWO_PI 6.283185

void main()	{
    float aspect = RENDERSIZE.y / RENDERSIZE.x;
    float x = (isf_FragNormCoord.x - 0.5);
    float y = (isf_FragNormCoord.y - 0.5) * aspect;

    float red = sin((x * cos(radians) + y * sin(radians)) * density);
    float green = sin((x * cos(radians + TWO_PI * 1/3) + y * sin(radians + TWO_PI * 1/3)) * density);
    float blue = sin((x * cos(radians + TWO_PI * 2/3) + y * sin(radians + TWO_PI * 2/3)) * density);
    float alpha = 1;

    gl_FragColor = vec4(red, green, blue, alpha);
}
